package net.minecraft.world.level.levelgen.structure;

import net.minecraft.world.level.block.state.StateHolder;
import java.util.Iterator;
import net.minecraft.world.level.storage.loot.BuiltInLootTables;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.core.Direction;
import net.minecraft.world.level.block.StairBlock;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.ChunkPos;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.StructureFeatureManager;
import net.minecraft.world.level.WorldGenLevel;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.level.levelgen.structure.templatesystem.StructureManager;
import net.minecraft.world.level.levelgen.feature.StructurePieceType;
import java.util.Random;

public class DesertPyramidPiece extends ScatteredFeaturePiece {
    private final boolean[] hasPlacedChest;
    
    public DesertPyramidPiece(final Random random, final int integer2, final int integer3) {
        super(StructurePieceType.DESERT_PYRAMID_PIECE, random, integer2, 64, integer3, 21, 15, 21);
        this.hasPlacedChest = new boolean[4];
    }
    
    public DesertPyramidPiece(final StructureManager cva, final CompoundTag le) {
        super(StructurePieceType.DESERT_PYRAMID_PIECE, le);
        (this.hasPlacedChest = new boolean[4])[0] = le.getBoolean("hasPlacedChest0");
        this.hasPlacedChest[1] = le.getBoolean("hasPlacedChest1");
        this.hasPlacedChest[2] = le.getBoolean("hasPlacedChest2");
        this.hasPlacedChest[3] = le.getBoolean("hasPlacedChest3");
    }
    
    @Override
    protected void addAdditionalSaveData(final CompoundTag le) {
        super.addAdditionalSaveData(le);
        le.putBoolean("hasPlacedChest0", this.hasPlacedChest[0]);
        le.putBoolean("hasPlacedChest1", this.hasPlacedChest[1]);
        le.putBoolean("hasPlacedChest2", this.hasPlacedChest[2]);
        le.putBoolean("hasPlacedChest3", this.hasPlacedChest[3]);
    }
    
    @Override
    public boolean postProcess(final WorldGenLevel bqu, final StructureFeatureManager bqq, final ChunkGenerator cha, final Random random, final BoundingBox ctd, final ChunkPos bph, final BlockPos fu) {
        this.generateBox(bqu, ctd, 0, -4, 0, this.width - 1, 0, this.depth - 1, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        for (int integer9 = 1; integer9 <= 9; ++integer9) {
            this.generateBox(bqu, ctd, integer9, integer9, integer9, this.width - 1 - integer9, integer9, this.depth - 1 - integer9, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
            this.generateBox(bqu, ctd, integer9 + 1, integer9, integer9 + 1, this.width - 2 - integer9, integer9, this.depth - 2 - integer9, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        }
        for (int integer9 = 0; integer9 < this.width; ++integer9) {
            for (int integer10 = 0; integer10 < this.depth; ++integer10) {
                final int integer11 = -5;
                this.fillColumnDown(bqu, Blocks.SANDSTONE.defaultBlockState(), integer9, -5, integer10, ctd);
            }
        }
        final BlockState cfj9 = ((StateHolder<O, BlockState>)Blocks.SANDSTONE_STAIRS.defaultBlockState()).<Comparable, Direction>setValue((Property<Comparable>)StairBlock.FACING, Direction.NORTH);
        final BlockState cfj10 = ((StateHolder<O, BlockState>)Blocks.SANDSTONE_STAIRS.defaultBlockState()).<Comparable, Direction>setValue((Property<Comparable>)StairBlock.FACING, Direction.SOUTH);
        final BlockState cfj11 = ((StateHolder<O, BlockState>)Blocks.SANDSTONE_STAIRS.defaultBlockState()).<Comparable, Direction>setValue((Property<Comparable>)StairBlock.FACING, Direction.EAST);
        final BlockState cfj12 = ((StateHolder<O, BlockState>)Blocks.SANDSTONE_STAIRS.defaultBlockState()).<Comparable, Direction>setValue((Property<Comparable>)StairBlock.FACING, Direction.WEST);
        this.generateBox(bqu, ctd, 0, 0, 0, 4, 9, 4, Blocks.SANDSTONE.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 1, 10, 1, 3, 10, 3, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.placeBlock(bqu, cfj9, 2, 10, 0, ctd);
        this.placeBlock(bqu, cfj10, 2, 10, 4, ctd);
        this.placeBlock(bqu, cfj11, 0, 10, 2, ctd);
        this.placeBlock(bqu, cfj12, 4, 10, 2, ctd);
        this.generateBox(bqu, ctd, this.width - 5, 0, 0, this.width - 1, 9, 4, Blocks.SANDSTONE.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, this.width - 4, 10, 1, this.width - 2, 10, 3, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.placeBlock(bqu, cfj9, this.width - 3, 10, 0, ctd);
        this.placeBlock(bqu, cfj10, this.width - 3, 10, 4, ctd);
        this.placeBlock(bqu, cfj11, this.width - 5, 10, 2, ctd);
        this.placeBlock(bqu, cfj12, this.width - 1, 10, 2, ctd);
        this.generateBox(bqu, ctd, 8, 0, 0, 12, 4, 4, Blocks.SANDSTONE.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 9, 1, 0, 11, 3, 4, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 9, 1, 1, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 9, 2, 1, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 9, 3, 1, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 10, 3, 1, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 11, 3, 1, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 11, 2, 1, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 11, 1, 1, ctd);
        this.generateBox(bqu, ctd, 4, 1, 1, 8, 3, 3, Blocks.SANDSTONE.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 4, 1, 2, 8, 2, 2, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 12, 1, 1, 16, 3, 3, Blocks.SANDSTONE.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 12, 1, 2, 16, 2, 2, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 5, 4, 5, this.width - 6, 4, this.depth - 6, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 9, 4, 9, 11, 4, 11, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 8, 1, 8, 8, 3, 8, Blocks.CUT_SANDSTONE.defaultBlockState(), Blocks.CUT_SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 12, 1, 8, 12, 3, 8, Blocks.CUT_SANDSTONE.defaultBlockState(), Blocks.CUT_SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 8, 1, 12, 8, 3, 12, Blocks.CUT_SANDSTONE.defaultBlockState(), Blocks.CUT_SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 12, 1, 12, 12, 3, 12, Blocks.CUT_SANDSTONE.defaultBlockState(), Blocks.CUT_SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 1, 1, 5, 4, 4, 11, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, this.width - 5, 1, 5, this.width - 2, 4, 11, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 6, 7, 9, 6, 7, 11, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, this.width - 7, 7, 9, this.width - 7, 7, 11, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 5, 5, 9, 5, 7, 11, Blocks.CUT_SANDSTONE.defaultBlockState(), Blocks.CUT_SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, this.width - 6, 5, 9, this.width - 6, 7, 11, Blocks.CUT_SANDSTONE.defaultBlockState(), Blocks.CUT_SANDSTONE.defaultBlockState(), false);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 5, 5, 10, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 5, 6, 10, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 6, 6, 10, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), this.width - 6, 5, 10, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), this.width - 6, 6, 10, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), this.width - 7, 6, 10, ctd);
        this.generateBox(bqu, ctd, 2, 4, 4, 2, 6, 4, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, this.width - 3, 4, 4, this.width - 3, 6, 4, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.placeBlock(bqu, cfj9, 2, 4, 5, ctd);
        this.placeBlock(bqu, cfj9, 2, 3, 4, ctd);
        this.placeBlock(bqu, cfj9, this.width - 3, 4, 5, ctd);
        this.placeBlock(bqu, cfj9, this.width - 3, 3, 4, ctd);
        this.generateBox(bqu, ctd, 1, 1, 3, 2, 2, 3, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, this.width - 3, 1, 3, this.width - 2, 2, 3, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.placeBlock(bqu, Blocks.SANDSTONE.defaultBlockState(), 1, 1, 2, ctd);
        this.placeBlock(bqu, Blocks.SANDSTONE.defaultBlockState(), this.width - 2, 1, 2, ctd);
        this.placeBlock(bqu, Blocks.SANDSTONE_SLAB.defaultBlockState(), 1, 2, 2, ctd);
        this.placeBlock(bqu, Blocks.SANDSTONE_SLAB.defaultBlockState(), this.width - 2, 2, 2, ctd);
        this.placeBlock(bqu, cfj12, 2, 1, 2, ctd);
        this.placeBlock(bqu, cfj11, this.width - 3, 1, 2, ctd);
        this.generateBox(bqu, ctd, 4, 3, 5, 4, 3, 17, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, this.width - 5, 3, 5, this.width - 5, 3, 17, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 3, 1, 5, 4, 2, 16, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.generateBox(bqu, ctd, this.width - 6, 1, 5, this.width - 5, 2, 16, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        for (int integer12 = 5; integer12 <= 17; integer12 += 2) {
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 4, 1, integer12, ctd);
            this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), 4, 2, integer12, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), this.width - 5, 1, integer12, ctd);
            this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), this.width - 5, 2, integer12, ctd);
        }
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 10, 0, 7, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 10, 0, 8, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 9, 0, 9, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 11, 0, 9, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 8, 0, 10, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 12, 0, 10, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 7, 0, 10, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 13, 0, 10, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 9, 0, 11, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 11, 0, 11, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 10, 0, 12, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 10, 0, 13, ctd);
        this.placeBlock(bqu, Blocks.BLUE_TERRACOTTA.defaultBlockState(), 10, 0, 10, ctd);
        for (int integer12 = 0; integer12 <= this.width - 1; integer12 += this.width - 1) {
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 2, 1, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 2, 2, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 2, 3, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 3, 1, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 3, 2, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 3, 3, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 4, 1, ctd);
            this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), integer12, 4, 2, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 4, 3, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 5, 1, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 5, 2, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 5, 3, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 6, 1, ctd);
            this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), integer12, 6, 2, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 6, 3, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 7, 1, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 7, 2, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 7, 3, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 8, 1, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 8, 2, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 8, 3, ctd);
        }
        for (int integer12 = 2; integer12 <= this.width - 3; integer12 += this.width - 3 - 2) {
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12 - 1, 2, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 2, 0, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12 + 1, 2, 0, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12 - 1, 3, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 3, 0, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12 + 1, 3, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12 - 1, 4, 0, ctd);
            this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), integer12, 4, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12 + 1, 4, 0, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12 - 1, 5, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 5, 0, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12 + 1, 5, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12 - 1, 6, 0, ctd);
            this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), integer12, 6, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12 + 1, 6, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12 - 1, 7, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12, 7, 0, ctd);
            this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), integer12 + 1, 7, 0, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12 - 1, 8, 0, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12, 8, 0, ctd);
            this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), integer12 + 1, 8, 0, ctd);
        }
        this.generateBox(bqu, ctd, 8, 4, 0, 12, 6, 0, Blocks.CUT_SANDSTONE.defaultBlockState(), Blocks.CUT_SANDSTONE.defaultBlockState(), false);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 8, 6, 0, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 12, 6, 0, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 9, 5, 0, ctd);
        this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), 10, 5, 0, ctd);
        this.placeBlock(bqu, Blocks.ORANGE_TERRACOTTA.defaultBlockState(), 11, 5, 0, ctd);
        this.generateBox(bqu, ctd, 8, -14, 8, 12, -11, 12, Blocks.CUT_SANDSTONE.defaultBlockState(), Blocks.CUT_SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 8, -10, 8, 12, -10, 12, Blocks.CHISELED_SANDSTONE.defaultBlockState(), Blocks.CHISELED_SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 8, -9, 8, 12, -9, 12, Blocks.CUT_SANDSTONE.defaultBlockState(), Blocks.CUT_SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 8, -8, 8, 12, -1, 12, Blocks.SANDSTONE.defaultBlockState(), Blocks.SANDSTONE.defaultBlockState(), false);
        this.generateBox(bqu, ctd, 9, -11, 9, 11, -1, 11, Blocks.AIR.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.placeBlock(bqu, Blocks.STONE_PRESSURE_PLATE.defaultBlockState(), 10, -11, 10, ctd);
        this.generateBox(bqu, ctd, 9, -13, 9, 11, -13, 11, Blocks.TNT.defaultBlockState(), Blocks.AIR.defaultBlockState(), false);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 8, -11, 10, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 8, -10, 10, ctd);
        this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), 7, -10, 10, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 7, -11, 10, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 12, -11, 10, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 12, -10, 10, ctd);
        this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), 13, -10, 10, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 13, -11, 10, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 10, -11, 8, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 10, -10, 8, ctd);
        this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), 10, -10, 7, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 10, -11, 7, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 10, -11, 12, ctd);
        this.placeBlock(bqu, Blocks.AIR.defaultBlockState(), 10, -10, 12, ctd);
        this.placeBlock(bqu, Blocks.CHISELED_SANDSTONE.defaultBlockState(), 10, -10, 13, ctd);
        this.placeBlock(bqu, Blocks.CUT_SANDSTONE.defaultBlockState(), 10, -11, 13, ctd);
        for (final Direction fz14 : Direction.Plane.HORIZONTAL) {
            if (!this.hasPlacedChest[fz14.get2DDataValue()]) {
                final int integer13 = fz14.getStepX() * 2;
                final int integer14 = fz14.getStepZ() * 2;
                this.hasPlacedChest[fz14.get2DDataValue()] = this.createChest(bqu, ctd, random, 10 + integer13, -11, 10 + integer14, BuiltInLootTables.DESERT_PYRAMID);
            }
        }
        return true;
    }
}
